window.resizeTo(400,400);
list={};


function run(cmd){
	(new ActiveXObject('WScript.Shell')).Run(cmd);
}

function load(n,code){
	var s;
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>1)?(code?code:'_autodetect'):'utf-8';
		Open();
		loadFromFile(n);
		s=ReadText();
		Close();
	}
	return(s);
}
function save(str,n,code){
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>2)?code:'utf-8';
		Open();
		WriteText(str);
		saveToFile(n,2);
		Close();
	}
}
function fromJSON(str){
	var __FROM_JSON_TEMP__;
	eval((''+str).replace(/^\s*/,'__FROM_JSON_TEMP__=')+';');
	return(__FROM_JSON_TEMP__);
}
function toJSON(obj){
	switch(typeof(obj)){
		case('object'):{
			if(obj==null){
				return('null');
			}else if(obj instanceof Array){
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(obj[i]));
				}
				return('[\n'+res.join(',\n')+'\n]');
			}else{
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(i)+':'+toJSON(obj[i]));
				}
				return('{\n'+res.join(',\n')+'\n}');
			}
		}case('boolean'):case('number'):{
			return(obj.toString());
		}case('function'):{
			return(obj.toString().replace(/\{\n +\[native code\]\n}$/,"{}"));
		}case('string'):{
			return('"'+obj.replace(/\\/g,"\\\\").replace(/[\n\r"]/g,function($1){switch($1){
					case("\n"):{return("\\n");}
					case("\r"):{return("\\r");}
					case('"'):{return('\\"');}
				}})+'"');
		}
	}
}
function loadJSON(name){
	return(fromJSON(load(name)));
}
function saveJSON(obj,file){
	save(toJSON(obj),file);
}


function parseCommandLine(str){
	var res=str.match(/(".+?("|$)|[^ @]+)/g);
	if(res){
		for(var i=0;i<res.length;i++){
			res[i]=res[i].replace(/^\+/,'').replace(/^"(.*)"$/,'$1');
		}
	}
	return(res);
}



function load_site(){
	var fso=new ActiveXObject("Scripting.FileSystemObject");
	var dir=fso.GetFolder(basedir+"sites");
	add_site('',"URLF");
	for(var e=new Enumerator(dir.Files);!e.atEnd();e.moveNext()){
		var n=e.item().Name;
		if(n.match(/\.js$/)){
			add_site(n.replace(/\.js$/,""));
		}
	}
	
}


function add_site(n,text){
	var e=document.createElement("option");
	var sel=document.getElementById("Site");
	e.value=n;
	e.innerHTML=text||n;
	sel.appendChild(e);
}

function get_site(){
	return(document.getElementById('Site').value);
}

function get_word(){
	return(document.getElementById('q').value.split(/[\n\r]+/));
}

function load_list(){
	list=loadJSON(basedir+"data\\list.js");
}
function show_list(){
	var html=[];
	for(var id in list){
		html.push('<li class="Item"><input type="button" value="폜" onclick="remove_list('+id+')" />'+list[id].site+': '+list[id].word+'</li>');
	}
	document.getElementById('List').innerHTML=html.join('');
}

function save_list(){
	saveJSON(list,basedir+"data\\list.js");
}

function add_list(){
	var site=get_site();
	var words=get_word();
	
	for(var i=0;i<words.length;i++){
		if(words[i]){
			list[(new Date()).getTime()]={word:words[i],site:site};
		}
	}
	save_list();
	show_list();
}
function remove_list(id){
	delete(list[id]);
	save_list();
	show_list();
}

function search(){
	var site=get_site();
	var word=get_word();
	var c='cmd /k cscript //NoLogo "'+basedir+'crawl.js" "'+site+'" "'+word+'"';
	if(document.getElementById('GetDLKeys').checked){
		c=c+' --get_keylist';
	}
	run(c);
}

function execute(){
	var c='cscript //NoLogo "'+basedir+'crawl.js"';
	if(document.getElementById('ShowWindow').checked){
		c='cmd /k '+c;
	}
	if(document.getElementById('GetDLKeys').checked){
		c=c+' --get_keylist';
	}
	run(c);
}





function init(){
	basedir=parseCommandLine(HTA.commandLine)[0].replace(/[^\\]*$/,'');
	try{load_site();}catch(e){}
	try{load_list();}catch(e){}
	try{show_list();}catch(e){}
}


