#Include %A_ScriptDir%\CommonArc.ahk


Malloc(size,flag=0x40){
	return DllCall("kernel32.dll\GlobalAlloc","UInt",flag,"UInt",size,"UInt")
}
Free(p){
	DllCall("kernel32.dll\GlobalFree",UInt,p,UInt)
}
UTF8ToSJIS(utf8){
	buf_w:=Malloc(1024)
	len:=DllCall("kernel32.dll\MultiByteToWideChar","UInt",65001,"UInt",0,"Str",utf8,"Int",-1,"UInt",buf_w,"Int",1024)
	VarSetCapacity(mbstr,1024)
	DllCall("kernel32.dll\WideCharToMultiByte","UInt",0,"UInt",0,"UInt",buf_w,"Int",len,"Str",mbstr,"Int",1024,"UInt",0,"UInt",0)
	Free(buf_w)
	return mbstr
}
ConvertDict(infile,outfile,msg){
	list=
	FileDelete,%outfile%
	Loop,READ,%infile%,%outfile%
	{
		str:=UTF8ToSJIS(A_LoopReadLine)
		if(StrLen(str)<=64){
			str:=RegExReplace(str,"_"," ")
			list=%list%%str%`n
			if(RegExMatch(str,"^[A-Z]")){
				str:=RegExReplace(str,"^[A-Z]","$L{0}")
				list=%list%%str%`n
			}
			if(Mod(A_Index,10000)=0){
				Progress,,%msg% %A_Index% 
				Sleep,-1
				FileAppend,%list%
				list=
			}
		}
	}
	FileAppend,%list%,%outfile%
}

mkdir(path){
	DllCall("kernel32.dll\CreateDirectoryA","Str",path,"UInt",0)
}

destdir=%1%

Process,Priority,,Low
SetBatchLines,-1

mkdir(destdir)

ja=http://download.wikimedia.org/jawiki/latest/jawiki-latest-all-titles-in-ns0.gz
en=http://download.wikimedia.org/enwiki/latest/enwiki-latest-all-titles-in-ns0.gz

Progress,M w400 h60

Progress,% 0*100/6,(1/6) ujav̌oꗗ_E[h
URLDownloadToFile,%ja%,%destdir%\list_ja.gz

Progress,% 1*100/6,(2/6) uenv̌oꗗ_E[h
URLDownloadToFile,%en%,%destdir%\list_en.gz

Progress,% 2*100/6,(3/6) ujav̌oꗗ𓀒
ArcExtract(destdir . "\list_ja.gz","list_ja",destdir . "\")

Progress,% 3*100/6,(4/6) uenv̌oꗗ𓀒
ArcExtract(destdir . "\list_en.gz","list_en",destdir . "\")


Progress,% 4*100/6,(5/6) ujav̌oꗗϊ
ConvertDict(destdir "\list_ja", destdir "\Wikipedia_ja.txt","(5/6) ujav̌oꗗϊ")


Progress,% 5*100/6,(5/6) uenv̌oꗗϊ
ConvertDict(destdir "\list_en", destdir "\Wikipedia_en.txt","(5/6) uenv̌oꗗϊ")

FileDelete,%destdir%\list_ja.gz
FileDelete,%destdir%\list_en.gz
FileDelete,%destdir%\list_ja
FileDelete,%destdir%\list_en


