basedir=WScript.ScriptFullName.replace(/[^\\]+$/,"");







Array.prototype.unique=function(){
	var res=[];
	var k={};
	for(var i=0;i<this.length;i++){
		if(!k[this[i]]){
			res.push(this[i]);
			k[this[i]]=true;
		}
	}
	return(res);
};




function load(n,code){
	var s;
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>1)?(code?code:'_autodetect'):'utf-8';
		Open();
		loadFromFile(n);
		s=ReadText();
		Close();
	}
	return(s);
}
function save(str,n,code){
	with(new ActiveXObject("ADODB.Stream")){
		Charset=(arguments.length>2)?code:'utf-8';
		Open();
		WriteText(str);
		saveToFile(n,2);
		Close();
	}
}
function fromJSON(str){
	var __FROM_JSON_TEMP__;
	eval((''+str).replace(/^\s*/,'__FROM_JSON_TEMP__=')+';');
	return(__FROM_JSON_TEMP__);
}
function toJSON(obj){
	switch(typeof(obj)){
		case('object'):{
			if(obj==null){
				return('null');
			}else if(obj instanceof Array){
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(obj[i]));
				}
				return('[\n'+res.join(',\n')+'\n]');
			}else{
				var res=new Array;
				for(var i in obj){
					res.push(toJSON(i)+':'+toJSON(obj[i]));
				}
				return('{\n'+res.join(',\n')+'\n}');
			}
		}case('boolean'):case('number'):{
			return(obj.toString());
		}case('function'):{
			return(obj.toString().replace(/\{\n +\[native code\]\n}$/,"{}"));
		}case('string'):{
			return('"'+obj.replace(/\\/g,"\\\\").replace(/[\n\r"]/g,function($1){switch($1){
					case("\n"):{return("\\n");}
					case("\r"):{return("\\r");}
					case('"'):{return('\\"');}
				}})+'"');
		}
	}
}
function loadJSON(name){
	return(fromJSON(load(name)));
}
function saveJSON(obj,file){
	save(toJSON(obj),file);
}

function safe_name(name){
	return(name.replace(/[^ ()+,-.;=@^_`{}0-9A-Za-zN}L~---σ-քF@-v]\efghdc񁌁T-]@-I-ˁ́́݁΁ށ-ځa-臓߁⁼ۇ܇@-S---@-VX-l-J-U@-E-S-ei`cakjdlfn_mbgh~-rso-qut-II-`-]/g,'_'));
}

function undup_name(path){
	if(file_exists(path) && path.match(/^(.*?)(\d*)(\.\w+)?$/)){
		var i=RegExp.$2||0;
		var base=RegExp.$1;
		var ext=RegExp.$3;
		i++;
		return(undup_name(base+i+ext));
	}else{
		return(path);
	}
}

function file_exists(path){
	var fso=(new ActiveXObject("Scripting.FileSystemObject"));
	return(fso.FileExists(path)||fso.FolderExists(path));
}



function mkdir(path){
	try{
		with((new ActiveXObject("Scripting.FileSystemObject"))){
			if(path.match(/^(.*)\\([^\\]*)\\?$/)){
				if(!FolderExists(RegExp.$1)){
					mkdir(RegExp.$1);
				}
				CreateFolder(path);
			}
		}
	}catch(e){
	}
}
function file_delete(path){
	try{
		with((new ActiveXObject("Scripting.FileSystemObject"))){
			if(FileExists(path)){
				GetFile(path).Delete();
			}
		}
	}catch(e){
	}
}

function echo(msg){
	WScript.echo(msg);
}


$break={};$continue={};
function foreach(ary,func){
	for(var i=0;i<ary.length;i++){
		try{
			func(ary[i],i,ary);
		}catch(e){
			if(e==$break){
				break;
			}
		}
	}
}









function curl(options,workdir){
	//CURLɂHTTPANZXs
	var curl=basedir+"bin\\curl.exe";
	var cookie=basedir+"data\\cookie.txt";
	var cmd='"'+curl+'" -k -b "'+cookie+'" -c "'+cookie+'" -A "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)" -L '+options;
	var ws=new ActiveXObject("WScript.Shell");
	if(workdir){
		ws.CurrentDirectory=workdir;
	}
	ws.Run(cmd,0,true);
}
function curl_clear(){
	file_delete(basedir+"data\\cookie.txt");
	file_delete(basedir+"data\\tmp_html.txt");
}


function get(url,no_charconv){
	//url擾ĕԂ
	if(get.cache[url]){
		return(get.cache[url]);
	}
	var file=basedir+"data\\tmp_html.txt";
	curl('-o "'+file+'" '+url);
	
	if(!no_charconv){
		var html=load(file,"_autodetect");
		if(html.match(/content="[^"]*charset=(.*?)"/i)){
			html=load(file,RegExp.$1);
		}
		if(is_html(html)){
			html=set_baseurl(html,url);
		}
		get.cache[url]=html;
	}else{
		var html=load(file,"ascii");
	}
	return(html);
}
get.cache={};


function post(url,d,no_load,is_multipart){
	//urlpostsAԂ
	var file=basedir+"data\\tmp_html.txt";
	var data;
	if(typeof(d)=='string'){
		data=' -d "'+d+'"';
	}else if(is_multipart){
		var data='';
		for(var i in d){
			data+=' -F "'+i+'='+d[i]+'"';
		}
	}else{
		var ary=[];
		for(var i in d){
			ary.push(encodeURIComponent(i)+'='+encodeURIComponent(d[i]));
		}
		data=' -d "'+ary.join('&')+'"';
	}
	curl('-o "'+file+'" '+data+' '+url);
	if(no_load){
		return(file);
	}else{
		var html=load(file,"");
		if(is_html(html)){
			html=set_baseurl(html,url);
		}
		return(html);
	}
}



function post_autofill_form(url,data,field,check,is_multipart){
	var pws=load(basedir+"data\\dlkeys.txt").split(/[\n\r]+/);
	echo("Auto filling form");
	for(var i in arguments.callee.passwords){
		pws.unshift(i);
	}
	for(var i=0;i<pws.length;i++){
		echo("try: "+pws[i]);
		data[field]=pws[i];
		if(typeof(check)=='function'){
			var fn=post(url,data,true,is_multipart);
			if(check(fn)){
				return(fn);
			}
		}else{
			var html=post(url,data,false,is_multipart);
			if(html.match(check)){
				return(html);
			}
		}
	}
	return;
}



function download(url,dir){
	mkdir(dir);
	curl('-O '+url,dir);
}



function move_file(src,dest){
	var fso=new ActiveXObject("Scripting.FileSystemObject");
	fso.MoveFile(src,dest);
}


function is_html(str){
	return(!!str.match(/<html/i));
}

function get_tags(html,name){
	//HTML^O𓾂
	//naméu|v؂ŕw\
	return(html.match(new RegExp("<("+name+")\\b[^>]*>(.*?</\\1>|)","ig")));
}
function get_tag(html,name){
	var ary=get_tags(html,name)||[];
	if(ary.length>0){
		return(ary[0]);
	}else{
		return(null);
	}
}

function decode_htmlspecialchars(str){
	var dict={'amp':'&','gt':'>','lt':'<','quot':'"','nbsp':' '};
	return(str.replace(/&([a-z]+);/,function($0,$1){
		return(dict[$1]||$0);
	}));
}

function get_attr(tag,name){
	//HTML^O瑮l𓾂
	if(tag.match(new RegExp("\\b(?:"+name+")=[\"']([^\"']*)","i"))){
		return(decode_htmlspecialchars(RegExp.$1));
	}else if(tag.match(new RegExp("\\b(?:"+name+")=([^ >]*)","i"))){
		return(decode_htmlspecialchars(RegExp.$1));
	}else{
		return(null);
	}
}

function build_url(baseurl,suburl){
	if(suburl.match(/^https?:/)){
		return(suburl);
	}else if(suburl.match(/^\//)){
		return(baseurl.replace(/(^http:\/\/[^/]*).*$/,"$1") + suburl);
	}else{
		var a=baseurl.replace(/^http:\/\/[^/]*\//,"").split("/");
		var b=suburl.split("/");
		var c=[];
		a.pop();
		a=a.concat(b);
		for(var i=0;i<a.length;i++){
			if(a[i]=='.'){
			}else if(a[i]=='..'){
				c.pop();
			}else{
				c.push(a[i]);
			}
		}
		return(baseurl.replace(/(^http:\/\/[^/]*\/).*$/,"$1") + c.join("/"));
	}
}

function omit_urloption(url){
	return(url.replace(/^(?:.* )?(http:[^ ]*)$/,"$1"));
}

function get_baseurl(html){
	//HTMLbase^OɂURL擾
	var tag=get_tag(html,"base");
	if(tag){
		return(get_attr(tag,'href'));
	}
}

function set_baseurl(html,url,overwrite){
	//base^OɂURLݒ
	url=omit_urloption(url);
	if(url && (overwrite||!get_baseurl(html))){
		var tag='<base href="'+url+'">';
		return(html.replace(/<base[^>]*>/i,"").replace(/<\/head>|<body/i,function($0){return(tag+$0);}));
	}
}

function extract_links(html,pattern){
	var list;
	var p2=null;
	var base=get_baseurl(html);
	
	if(!pattern || pattern.constructor!='RegExp'){
		var list=get_tags(html,"a|img|iframe");
		p2=new RegExp(pattern);
	}else{
		var list=html.match(pattern)||[];
	}
	var result=[];
	for(var i=0;i<list.length;i++){
		if(!p2 || list[i].match(p2)){
			var url=get_attr(list[i],'href')||get_attr(list[i],'src');
			if(url){
				if(base){
					result.push('-e "'+base+'" '+build_url(base,url));
				}else{
					result.push(url);
				}
			}
		}
	}
	return(result);
}


function extract_scripts(html){
	var result=[];
	html.replace(/<script[^>]*>([^\x00]*?)<\/script>|<[^>]*\bonclick=["']([^"']*)/gi,function($0,$content,$onclick){
		result.push($content||$onclick);
	});
	return(result);
	
	
}




function extract_script_links(html,find){
	var result=[];
	var base=get_baseurl(html);
	foreach(extract_scripts(html),function(s){
		s.replace(/\b(open|write)\((.*?)\)(;|$)/ig,function($0,$mtd,$c){
			try{
				var h=eval($c);
				var url=($mtd=='onpen')? $h : get_attr(h,'href')||get_attr(h,'src');
				if(url && (!find || url.match(find))){
					if(base){
						result.push('-e "'+base+'" '+build_url(base,url));
					}else{
						result.push(url);
					}
				}
			}catch(e){
			}
		});
		
	});
	return(result);
}



function get_site(name){
	//TCg`t@Cǂݍ݁Aʃ\bh̒ǉ
	try{
		var site=loadJSON(basedir+"sites\\"+name);
	}catch(e){
		throw(name+' ̃TCg`t@Cǂݍ݃G[');
	}
	if(!site.Init){
		site.Init=function(){};
	}
	if(!site.GetFirstPageURL){
		site.GetFirstPageURL=function(word){return(word);};
	}
	if(!site.GetNextPageURL){
		site.GetNextPageURL=function(){};
	}
	if(!site.GetFileURL){
		site.GetFileURL=function(url){return(url)};
	}
	if(!site.GetURLs){
		site.GetURLs=function(html){return([])};
	}
	if(!site.IsSupportedList){
		site.IsSupportedList=function(){return(false);};
	}
	if(!site.IsSupportedItem){
		site.IsSupportedItem=function(){return(false);};
	}
	if(!site.DownloadFile){
		site.DownloadFile=function(url,dir){
			var file_url=this.GetFileURL(url);
			if(file_url){
				download(file_url,dir);
				return(omit_urloption(file_url));
			}else{
				return("");
			}
			
		};
	}
	if(!site.name){
		site.name=name.replace(/\.js/,'');
	}
	
	return(site);
}

//URLɑΉTCg
function search_site(url){
	var fso=new ActiveXObject("Scripting.FileSystemObject");
	var dir=fso.GetFolder(basedir+"sites");
	for(var e=new Enumerator(dir.Files);!e.atEnd();e.moveNext()){
		var site=get_site(e.item().Name);
		if(site.IsSupportedList(url)||site.IsSupportedItem(url)){
			return(site);
		}
	}
	return(null);
}


function execute(s,w){
	var downloaded="";
	try{downloaded=load(basedir+"data\\downloaded.txt");}catch(e){}
	echo(s+"["+w+"]̎擾Jn");
	var site;
	if(!s || s=='auto'){
		site=search_site(w);
		if(site){
			echo("ΉTCg`F: "+site.name);
		}else{
			throw "ΉTCg܂";
		}
		if(site.IsSupportedItem(w)){
			var savedir=(config.no_subdir ? config.savedir.replace(/\\$/,'') : config.savedir+safe_name(site.name));
			mkdir(savedir);
			var dl_url=site.DownloadFile(w,savedir);
			if(dl_url){
				echo(dl_url);
				downloaded+=dl_url+"\n";
				save(downloaded,basedir+"data\\downloaded.txt");
			}
			curl_clear();
			return;
		}
	}else{
		site=get_site(s+'.js');
	}
	var savedir=(config.no_subdir ? config.savedir.replace(/\\$/,'') : config.savedir+safe_name(site.name)+"\\"+safe_name(w));
	site.Init();
	var page_url=site.GetFirstPageURL(w);
	var end=false;
	var cnt=0;
	while(!end && page_url){
		echo("y[W擾: "+omit_urloption(page_url));
		var page_html=get(page_url);
		foreach(site.GetURLs(page_html),function(item_url){
			var url2=omit_urloption(item_url);
			if(config.test_only){
				echo(item_url);
			}else{
				if(downloaded.indexOf(url2+"\n")==-1){
					var dl_url=site.DownloadFile(item_url,savedir);
					if(dl_url){
						echo(dl_url);
						downloaded+=dl_url+"\n";
						cnt++;
					}
				}else{
					end=true;
					echo("擾ςݕɓB");
					throw($break);
				}
				if(cnt>=config.max_files){
					echo("擾̏ɓB");
					end=true;
					throw($break);
				}
			}
		});
		if(!end){
			page_url=""+(site.GetNextPageURL(page_html)||"");
		}
	}
	save(downloaded,basedir+"data\\downloaded.txt");
	curl_clear();
}



function crawl_all(){
	var fso=new ActiveXObject("Scripting.FileSystemObject");
	var dir=fso.GetFolder(basedir+"data");
	for(var e=new Enumerator(dir.Files);!e.atEnd();e.moveNext()){
		if(e.item().Name.match(/list\.js$/)){
			var list=loadJSON(e.item().Path);
			for(var i in list){
				try{
					execute(list[i].site,list[i].word);
				}catch(e){
					echo(e.message||e);
				}
			}
		}
	}
}

function for_tree(dir,func){
	var dir2;
	if(typeof(dir)=='string'){
		var fso=new ActiveXObject("Scripting.FileSystemObject");
		var dir2=fso.GetFolder(dir);
	}else{
		dir2=dir;
	}
	for(var e=new Enumerator(dir2.SubFolders);!e.atEnd();e.moveNext()){
		for_tree(e.item(),func);
	}
	for(var e=new Enumerator(dir2.Files);!e.atEnd();e.moveNext()){
		func(e.item());
	}
}



start_time=new Date;

config={
	savedir:basedir+"download\\",
	max_files:200
};
try{
	var config2=loadJSON(basedir+"data\\config.js");
	for(var i in config2){
		config[i]=config2[i];
	}
}catch(e){
}




var args=[];
var paramname='';
var bool_params={'get_keylist':1,'test_only':1,'no_subdir':1};
for(var i=0;i<WScript.Arguments.length;i++){
	if(paramname){
		config[paramname]=WScript.Arguments(i);
		paramname='';
	}else if(WScript.Arguments(i).match(/--(\w+)/)){
		if(bool_params[RegExp.$1]){
			config[RegExp.$1]=true;
		}else{
			paramname=RegExp.$1;
		}
	}else{
		args.push(WScript.Arguments(i));
	}
}
if(config.savepath){
	config.savedir=config.savepath.replace(/\\[^\\]*$/,'\\');
	config.no_subdir=true;
}


if(config.get_keylist){
	curl('-o "'+basedir+'data\\dlkeys.txt" http://www.netamitan.com/unzipper/index.php?mode=keylist');
}

if(args.length<2){
	crawl_all();
}else{
	for(var i=1;i<args.length;i++){
		try{
			execute(args[0],args[i]);
		}catch(e){
			echo(e.message||e);
		}
	}
}

if(config.savepath){
	for_tree(config.savedir,function(f){
		if(f.DateLastModified>start_time){
			move_file(f,undup_name(config.savepath));
		}
	});
	
	
}else if(!config.no_list){
	var l='';
	try{
		l=load(config.savedir+'RecentDownloads.sz7');
	}catch(e){
	}

	for_tree(config.savedir,function(f){
		if(f.Name.match(/\.(jpeg|jpg|png|gif|bmp)$/) && f.DateLastModified>start_time){
			l+=f.Path+'\r\n';
		}
	});
	save(l,config.savedir+'RecentDownloads.sz7','Shift_JIS');
}

